// prof. Chesca Ciprian
// sursa 100 p, O(log(min(a1,b1))+log(min(a2,b2)))


#include <fstream>
#include <cassert>

#define nmax 1000

using namespace std;

int main()
{
    long long a1,b1,a2,b2,T;
    long long w1[nmax],w2[nmax];
    long long d, i, j, k, c, r; // teorema impartirii cu rest
    long long k1,k2,ok1,ok2,s;

    ifstream fin("numinum.in");
    ofstream fout("numinum.out");
    fin >> T;
    assert(T>=1 && T<=10000); 	

for(k=1;k<=T;k++)
    {
    fin >> a1 >> b1 >> a2 >> b2;
    assert(a1>=1 && a1<=1000000000);
    assert(b1>=1 && b1<=1000000000);
    assert(a2>=1 && a2<=1000000000);
    assert(b2>=1 && b2<=1000000000);

    // prima fractie.......................................................
    // determin fractia continua atasata primei fractii
    d = a1;i = b1; r = d%i; k1 = 0;
    if (r==0) w1[++k1] = d/i;
    while (r)
    {
        r = d%i;
        c = d/i;
        w1[++k1] = c;
        d = i;
        i = r;
    }
    // daca lungimea secventei este un numar par mai adaug un termen de 1
    if (k1%2==0)
        {w1[++k1]=1;w1[k1-1]--;}

    //calculez suma elementelor vectorului fractiei continue
    ok1=0;
    for(i=1;i<=k1;i++)
        ok1+=w1[i];


// fractia a doua...............................................................................
// determin fractia continua atasata cele de-a doua fractii
    d = a2;i = b2; r = d%i; k2 = 0;
    if (r==0) w2[++k2] = d/i;
    while (r)
    {
        r = d%i;
        c = d/i;
        w2[++k2] = c;
        d = i;
        i = r;
    }

    // daca lungimea secventei este un numar par mai adaug un termen de 1
    if (k2%2==0)
        {w2[++k2]=1;w2[k2-1]--;}


    //calculez suma elementelor vectorului fractiei continue
    ok2=0;
    for(i=1;i<=k2;i++)
        ok2+=w2[i];

    // determin secventa comuna celor doi vectori ai fractiilor continue
    i=k1;j=k2;s=0;
    while (i>=1 and j>=1)
    {
        if (w1[i]==w2[j])
                {
                 s=s+2*w1[i];
                 i--;j--;
                }
                else
                 {
                 if (w1[i]<w2[j])   s=s+2*w1[i];
                        else        s=s+2*w2[j];
                  break;
                 }
    }

    // afisez rezultatul
    fout << ok1 + ok2 - s << "\n";
    }

    fin.close();
    fout.close();



    return 0;
}
