// student Posdarascu Daniel - brute force

#include<stdio.h>
#include<cassert>
#include<algorithm>
#include<vector>
using namespace std;

#define NMAX 100005

long long n;
long long v[NMAX], p;

void findBazaFactoriala(long long n) {
	long long fact = 1, k;
	for(k = 1; ; k++) {
		if(fact * (k + 1) > n)
			break;
		fact *= (k + 1);
	}
	vector<int> answer;
	for(; k >= 1; k--) {
		answer.push_back(n / fact);	
		n %= fact;
		fact /= k;
	}
	
	long long lim = answer.size();
	printf("%d ", lim);
	for(int i = lim - 1; i >= 0; i--)
		printf("%d ", answer[i]);
	printf("\n");
}

void solve1() {
	scanf("%lld",&n);
	assert(1 <= n && n <= 1LL * 1000000000000000);
	findBazaFactoriala(n);	
}

void solve2() {
	long long fact = 1, value = 0;

	scanf("%lld",&n);
	assert(1 <= n && n <= 100000);
	for(int i = 1; i <= n; i++) {
		scanf("%d",&v[i]);
		assert(0 <= v[i] && v[i] <= 1000000000);
		fact *= i;
		value += v[i] * fact;
	}
	
	findBazaFactoriala(value);	
}

int main () {

	freopen("bazaf.in","r",stdin);
	freopen("bazaf.out","w",stdout);
	
	scanf("%d", &p);
	assert(1 <= p && p <= 2);
	if(p == 1) {
		solve1();
	}
	else {
		solve2();
	}	
	
	return 0;
}
 


