// student Daniel Posdarascu

#include<stdio.h>
#include<vector>
#include<algorithm>
using namespace std;

#define x first.first
#define y first.second
#define dist second

int a, b, c, d,T;
vector< pair<pair<int,int>, int> > mylist[3];

void getList(int index, int a, int b) {
    if(a == 1 && b == 1) {
        mylist[index].push_back(make_pair(make_pair(a, b), 0));
        return ;
    }

    int c;
    if(a < b) {
        if(a > 1) {
            c = b / a;
            getList(index, a, b % a);
        }
        else {
            c = b - 1;
            getList(index, 1, 1);
        }
    }
    else {
        if(b > 1) {
            c = a / b;
            getList(index, a % b, b);
        }
        else {
            c = a - 1;
            getList(index, 1, 1);
        }
    }
    mylist[index].push_back(make_pair(make_pair(a, b), c));
}

void clearAll() {
	mylist[1].clear();
	mylist[2].clear();	
}

int main () {

    freopen("numinum.in","r",stdin);
    freopen("numinum.out","w",stdout);

    scanf("%d",&T);
 for(int k=1;k<=T;k++)
 {

    scanf("%d%d%d%d",&a,&b,&c,&d);


    getList(1,a,b);
    getList(2,c,d);

    int lca = 0, lim1 = mylist[1].size(), lim2 = mylist[2].size();
    while(lca < lim1 && lca < lim2 && mylist[1][lca] == mylist[2][lca])
        lca++;


    int ans = 0;
    for(int i = lim1 - 1; i > lca; i--)
        ans += mylist[1][i].dist;
    for(int i = lim2 - 1; i > lca; i--)
        ans += mylist[2][i].dist;

    if(lca == lim1) {
        int A = mylist[2][lca].x;
        int B = mylist[2][lca].y;
        int C;
        if(A < B) {
            C = mylist[2][lca - 1].x;
            ans += (B - C) / A;
        }
        else {
            C = mylist[2][lca - 1].y;
            ans += (A - C) / B;
        }
		clearAll();
		continue;
    }

    if(lca == lim2) {
        int A = mylist[1][lca].x;
        int B = mylist[1][lca].y;
        int C;
        if(A < B) {
            C = mylist[1][lca - 1].x;
            ans += (B - C) / A;
        }
        else {
            C = mylist[1][lca - 1].y;
            ans += (A - C) / B;
        }
        clearAll();
        continue;
    }

    int A = mylist[1][lca].x;
    int B = mylist[1][lca].y;

    int C = mylist[2][lca].x;
    int D = mylist[2][lca].y;

    if(A < B) { // C > D
        ans += (C - A) / D + (B - D) / A;
    }
    else // A > B && C < D
        ans += (A - C) / B + (D - B) / C;

    printf("%d\n", ans);
    clearAll();
 }
    return 0;
}

