#include <fstream>
#include <cstdio>
#include <vector>
#include <cassert>
using namespace std;
int main(){
    ifstream fin("bsrec.in");
    ofstream fout("bsrec.out");
    int t;
    fin >> t;
    while(t--) {
        int n, q;
        fin >> n >> q;
        vector<int> maxx(n + 1, 1<<30);
        vector<int> minn(n + 1, 1);
        while(q--> 0) {
            int x, mid, m;
            fin >> x >> m;
            for(int i = 1;i <= m;i++) {
                int l, r;
                fin >> l >> r;
                if (i > 1) {
                    if(l == mid+1) {
                        maxx[mid] = min(maxx[mid], x - 1);
                    }
                    else {
                        minn[mid] = max(minn[mid], x);
                    }
                }
                mid = (l+r)/2;
            }
        }
        vector<int>sol;
        int x = 0;
        for(int i = 1; i <= n;i++)
        {
            x = max(minn[i], x + 1);
            if(x > maxx[i])
                break;
            sol.push_back(x);
        }
        if(sol.size() == n) {
            for(auto x: sol)
                fout << x << " ";
            fout <<"\n";
        }
        else
            fout << "-1\n";
    }

    return 0;
}


