#include <cstdio>
#include <vector>
#include <fstream>
#include <cassert>
#include <algorithm>
using namespace std;

int main() {
    ifstream fin("rosiimici.in");
    ofstream fout("rosiimici.out");
    int n, m, q;
    fin >> n >> m >> q;
    vector<vector<int>> a(m, vector<int>(n, 0));
    vector<vector<int>> b(n, vector<int>(m, 0));
    for(auto &line: b)
        for(auto &val: line)
            fin >> val;
    for (int i = 1; i < n;i++) 
       for (int j = 0; j < m;j++) 
            assert(b[i-1][j] <= b[i][j]);
    swap(n, m);
    for (int i = 0; i < n;i++) {
        for (int j = 0; j < m;j++) {
            a[i][j] = b[j][i];
        }
    }
    while(q-- > 0) {
        int x;
        fin >> x;
        vector<int>len(n, 0);
        for (int j = 0; j < n;j++) {
            len[j] = upper_bound(a[j].begin(), a[j].end(), x) - a[j].begin();
        }
        sort(len.begin(), len.end(), greater<int>());
        int ans = 0;
        for (int j = 0; j < n;j++) {
            ans = max(ans, len[j]*(j+1));
        }
        fout << ans << "\n";
    }
    return 0;
}

